/*
 * lab0.c
 *
 */


#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>

int pa_vect[8]={PA0,PA1,PA2,PA3,PA4,PA5,PA6,PA7};
int pc_vect[8]={PC0,PC1,PC2,PC3,PC4,PC5,PC6,PC7};


/* aprinde led-ul PC0 la apasarea butonului PB0 */
void exemplu() {
	
	/* setez pinul PB0 ca intrare */
	DDRD &= ~(1 << PD5);
	/* activez rezistenta de pull-up pentru pinul PB0*/
	PORTD |= (1 << PD5);

	/* setez pinul PC0 ca iesire */
	DDRC |= (1 << PC0);
	/* opresc LED-ul pe de pinul PC0 */
	PORTC &= ~(1 << PC0);
	
	while (1) {
		/* daca butonul este apasat */
		if ((PIND & (1 << PD5)) == 0) {
			/* ledul este aprins */
			PORTC |= (1 << PC0);
		} else {
			/* altfel ledul este stins */
			PORTC &= ~(1 << PC0);
		}
	}
}

int main(void) {

	int i;
	DDRA = 0xFF; 
	DDRC = 0xFF;
	
	while (1) {
		for (i = 0;i < 8;i++) {
		
			PORTC |= (1 << pc_vect[i]);
			_delay_ms(200);
			PORTC &=~ (1 << pc_vect[i]);
			
			
		}
		
		for (i = 7;i >= 0;i--) {
		
			
			PORTC |= (1 << pc_vect[i]);
			_delay_ms(300);
			PORTC &=~ (1 << pc_vect[i]);
		}
		
		PORTC = 0xFF;
		
		for (i = 0;i < 8;i++) {
		
			PORTA |= (1 << pa_vect[i]);
			_delay_ms(300);
			PORTA &=~ (1 << pa_vect[i]);
		}
		
		for (i = 7;i >= 0;i-=2){
		
			PORTA |= (1 << pa_vect[i]);
			_delay_ms(300);
			PORTA &=~ (1 << pa_vect[i]);
		}
		
		PORTC = 0x00;
	}

	return 0;
}

